/*
 * ICM20948.c
 *
 *  Created on: Jul 1, 2019
 *      Author: cs
 */

#include "ICM20948.h"

void icm_read_registers(ICM20948_t* handle, uint8_t reg, uint8_t *data, uint8_t size) {
	HAL_I2C_Master_Transmit(handle->_i2c_handle, handle->_address, &reg, 1, 1000);
	HAL_I2C_Master_Receive(handle->_i2c_handle, handle->_address, data, size, 1000);
}

void icm_write_registers(ICM20948_t* handle, uint8_t reg, uint8_t *data, uint8_t size) {
	HAL_I2C_Master_Transmit(handle->_i2c_handle, handle->_address, &reg, 1, 1000);
	HAL_I2C_Master_Receive(handle->_i2c_handle, handle->_address, data, size, 1000);
}

uint8_t icm_whoami(ICM20948_t* handle) {
	uint8_t result;
	icm_read_registers(handle, ICM_WHOAMI_REG, &result, 1);
	return result;
}

void icm_select_bank(ICM20948_t* handle, uint8_t bank) {
	icm_write_registers(handle, ICM_BANK_SEL_REG, &bank, 1);
}

uint8_t icm_initialize(ICM20948_t* handle) {
	if(icm_whoami(handle) != ICM_WHOAMI_VAL) {
		return 1;
	}


	return 0;
}

uint8_t icm_read_sensors(ICM20948_t* handle, uint8_t *data) {

	return 0;
}
