/*
 * ICM20948.h
 *
 *  Created on: Jul 1, 2019
 *      Author: cs
 */

#ifndef ICM20948_H_
#define ICM20948_H_

#include <stdint.h>
#include <stm32f1xx_hal.h>

typedef struct {
	I2C_HandleTypeDef* _i2c_handle;
	uint8_t _address;
} ICM20948_t;

void icm_read_registers(ICM20948_t* handle, uint8_t reg, uint8_t *data, uint8_t size);
void icm_write_registers(ICM20948_t* handle, uint8_t reg, uint8_t *data, uint8_t size);

uint8_t icm_whoami();
void icm_select_bank(ICM20948_t* handle, uint8_t bank);

uint8_t icm_initialize(ICM20948_t* handle);
uint8_t icm_read_sensors(ICM20948_t* handle, uint8_t *data);

#define ICM_I2C_BASE_ADDRESS 0b1101000
#define ICM_WHOAMI_VAL 0xEA

#define ICM_BANK_SEL_REG 0x7F
#define ICM_BANK0 0x00
#define ICM_BANK1 0x10
#define ICM_BANK2 0x20
#define ICM_BANK3 0x30

#define ICM_WHOAMI_REG 0x00

#endif /* ICM20948_H_ */
